package es.rotxo.escaner;


import android.support.v7.widget.CardView;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import java.util.Vector;

/**
 * Created by Rotxo on 25/07/2016.
 */
public class AdaptadorListado extends RecyclerView.Adapter<AdaptadorListado.BarrasViewHolder>
{


    private Vector<CodBarras> datos;
    public AdaptadorListado(Vector<CodBarras> datos) {
        this.datos = datos;
    }
    @Override
    public BarrasViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {

        View itemView = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.listitem_codigo, parent, false);

        BarrasViewHolder bvh = new BarrasViewHolder(itemView);

        return bvh;
    }

    @Override
    public void onBindViewHolder(BarrasViewHolder holder, int position) {
        CodBarras item = datos.get(position);

        holder.bindBarras(item);

    }
    @Override
    public void onAttachedToRecyclerView(RecyclerView recyclerView) {
        super.onAttachedToRecyclerView(recyclerView);
    }

    @Override
    public int getItemCount() {
        return datos.size();
    }

    public static class BarrasViewHolder extends RecyclerView.ViewHolder {

        private TextView txtCodigo;
        private TextView txtTipo;
        private TextView txtFecha;
        CardView cv;


        BarrasViewHolder(View itemView) {
            super(itemView);
            cv = (CardView)itemView.findViewById(R.id.cv);
            txtCodigo = (TextView)itemView.findViewById(R.id.txtBarras);
            txtTipo = (TextView)itemView.findViewById(R.id.txtTipo);
            txtFecha = (TextView)itemView.findViewById(R.id.txtFecha);
        }

        public void bindBarras(CodBarras cb) {
            txtCodigo.setText(cb.getCodigo());
            txtTipo.setText(cb.getTipo());
            txtFecha.setText(cb.getFecha());
        }
    }
}
