package es.rotxo.escaner;

import android.app.Application;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.preference.PreferenceManager;

import java.util.Vector;

/**
 * Created by Rotxo on 28/07/2016.
 */
public class Aplicacion extends Application
{


    private Vector<CodBarras> lista;
    private AdaptadorListado adaptador;
    //variables de preferencias
    private boolean guardarHistorial;



    private boolean multipleLectura;


    private String codigoBarras;
    private String codigoBarrasAnterior;


    private int zoomValor;



    private boolean torch;


    @Override
    public void onCreate() {
        super.onCreate();
        //base de datos
        lista=new Vector<CodBarras>();
        adaptador=new AdaptadorListado(lista);//adaptador del recycler view

        codigoBarras=codigoBarrasAnterior="";

        SharedPreferences preferencias = PreferenceManager.getDefaultSharedPreferences(this);
        guardarHistorial = (preferencias.getBoolean("Historial", true));
        String valorZoom=(preferencias.getString("zoomValor", "0"));
        zoomValorDePreferencias(valorZoom);
        multipleLectura = (preferencias.getBoolean("MultipleLectura", false));
        torch= (preferencias.getBoolean("torch", false));


    }


    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
    }


    @Override
    public void onLowMemory() {
        super.onLowMemory();
    }

    @Override
    public void onTerminate() {
        super.onTerminate();
    }
    //Vector codigo de Barras
    public Vector<CodBarras> getLista() {
        return lista;
    }
    public void AñadirCodBarras(String codigo,String tipo){
        if (guardarHistorial) {
            if (multipleLectura) {
                CodBarras cb = new CodBarras(codigo, tipo);
                lista.add(cb);
            }else
            {
                if (!ExisteCodBarras(codigo))
                {
                    CodBarras cb = new CodBarras(codigo, tipo);
                    lista.add(cb);
                }
            }
        }
    }
    private boolean ExisteCodBarras(String codigo)
    {
        boolean ok=false;
        for (int i=0;i<=lista.size()-1;i++)
        {
            if(lista.get(i).getCodigo().equals(codigo))
            {
                ok=true;
                break;
            }
        }
        return ok;
    }

    //adaptador
    public AdaptadorListado getAdaptador() {
        return adaptador;
    }

    public String getCodigoBarras() {
        return codigoBarras;
    }

    public void setCodigoBarras(String codigoBarras) {
        this.codigoBarras = codigoBarras;
    }

    public String getCodigoBarrasAnterior() {
        return codigoBarrasAnterior;
    }

    public void setCodigoBarrasAnterior(String codigoBarrasAnterior) {
        this.codigoBarrasAnterior = codigoBarrasAnterior;
    }

    public int getZoomValor() {
        return zoomValor;
    }


    public void zoomValorDePreferencias(String valor)
    {
        try
        {
            //establece el valor del zoom pero para evitar porblemas lo hacemos en un try cast, no funciona el devolver entero
            if (valor!=null) {

               int x=Integer.parseInt(valor);
                zoomValor=x;
            }
        }catch (Exception a)
        {

        }
    }

    public boolean isTorch() {
        return torch;
    }

    public void setTorch(boolean torch) {
        this.torch = torch;
    }



    public void setMultipleLectura(boolean multipleLectura) {
        this.multipleLectura = multipleLectura;
    }



    public void setGuardarHistorial(boolean guardarHistorial) {
        this.guardarHistorial = guardarHistorial;
    }
    public boolean hayDatosLista()
    {
        int x=lista.size();
        boolean haydatos=false;
        if (x>0)
            haydatos=true;

        return  haydatos;
    }





}
