package es.rotxo.escaner;

import android.util.Log;

import java.util.Vector;

/**
 * Created by Rotxo on 29/06/2016.
 */
public class Barras {




    private int nBarras;

    private Vector<Elemento> elementos;


    private String tipo;
    private int inicio;//indice guarda inicio en el array
    private int fin;//indice guarda fin en el array
    private int medio;////indice guarda media en el array
    private boolean encontrado;//marca si ha sido encontrado
    private EAN13 ean13;//clase EAN13 donde guarda y decodifica el código
    private int minimoSize;//minimo tamaña que tiene que terner para buscar ean , evita recorrer innecesariamente el aray

    private double Media0;
    private double Media1;





    private EAN8 ean8;//clase EAN8 donde guarda y decodifica el código

    public Barras()
    {
        this.encontrado=false;//para ver si lo hemos encontrado
        this.nBarras=0;// el numero de barras nos marca si es ean 13 ean8 ean2

        elementos =new Vector<Elemento>();//Guardaos la segmentacion de la imagen
        minimoSize=40;


    }

    public void GuardarDigito(Elemento d)
    {


        elementos.add(d);
    }
    //**********************************************************************************************
    //***************************Determina el tipo de codigo de barras******************************
    //**********************************************************************************************
    public void DeterminarTipo()
    {
           //Miramos si es de tipo EAN buscando la guarda de Incio

             if (EAN_BuscarGuardaInicio())
             {
                 //*****************************EAN13***********************************************
                 //MIRAMOS SI ES UN EAN13
                 fin=inicio+58;
                 if (EAN_BuscarGuardaFin( ))
                 {
                     //Es un EAN 13
                          //Para comprobarlo debemos encontrar la guarda central
                          this.tipo = "EAN13";
                          this.medio=this.inicio+27;//2 digitos de la guarda de inicion 6x4 de
                          if ( EAN_BuscarGuardaCentral())
                          {
                             nBarras= EAN_numerodeBarras();
                              Log.e("Barras", "Numero de Barras "+nBarras);
                              if (nBarras==30) {
                                  calcularPixelUnitario();
                                  //tenemos un codigo correcto procedemos a leer los digitos

                                  AsignarEan13();
                              }
                          }

                 }
                 else
                 {
                     //*****************************EAN8***********************************************
                     //Miramos si es un Ean8
                     fin=inicio+42;
                     if (EAN_BuscarGuardaFin( )) {
                         this.tipo = "EAN8";
                         this.medio=this.inicio+19;
                         if ( EAN_BuscarGuardaCentral()) {

                             nBarras= EAN_numerodeBarras();
                             Log.e("Barras", "Numero de Barras "+nBarras);
                             if (nBarras==22) {
                                 calcularPixelUnitario();
                                 //tenemos un codigo correcto procedemos a leer los digitos

                                 AsignarEan8();
                             }
                         }
                     }

                 }
             }

    }
    private void AsignarEan13() {

        Log.e("Barras", "Asignar EAN 13 ");
        ean13 = new EAN13();
        ean13.setGuardaInicio("101");
        ean13.setGuardaFin("101");
        ean13.setGuardaCentro("01010");
        encontrado=false;
        int x=inicio+3;
        boolean continuar=true;
        for (int i=2;i<=7;i++) {

            if(leerDigito(x,i))
                x+=4;
            else
            {
                continuar=false;
                break;
            }

        }
        if (continuar)
        {
            x=medio+5;
            for (int i=8;i<=13;i++) {

                if(leerDigito(x,i))
                    x+=4;
                else
                {
                    continuar=false;
                    break;
                }

            }
        }
        if (continuar)
        {
            if (ean13.getCorrecto()) {
                encontrado = true;
            }
        }






    }

    private boolean leerDigito(int i,int posicion)
    {
        boolean ok=false;
        int tipo1 = elementos.elementAt(i).getTipo();
        double pixeles1 = elementos.elementAt(i).getNpixels();
        int tipo2 = elementos.elementAt(i+1).getTipo();
        double pixeles2 = elementos.elementAt(i+1).getNpixels();
        int tipo3 = elementos.elementAt(i+2).getTipo();
        double pixeles3 = elementos.elementAt(i+2).getNpixels();
        int tipo4 = elementos.elementAt(i+3).getTipo();
        double pixeles4 = elementos.elementAt(i+3).getNpixels();
        //calculamos el modulo
        double total=pixeles1+pixeles2+pixeles3+pixeles4;
        double modulo1= (pixeles1/total)*7;
        double modulo2= (pixeles2/total)*7;
        double modulo3= (pixeles3/total)*7;
        double modulo4= (pixeles4/total)*7;
        //Redondeamos los digitos
        int ndigitos1=redondeaDigitos(modulo1);
        int ndigitos2=redondeaDigitos(modulo2);
        int ndigitos3=redondeaDigitos(modulo3);
        int ndigitos4=redondeaDigitos(modulo4);

        int sumadigitos=ndigitos1+ndigitos2+ndigitos3+ndigitos4;
        if (sumadigitos!=7)
        {
            //cambiamos el redondeo
            ndigitos1=redondeaDigitos2(modulo1);
            ndigitos2=redondeaDigitos2(modulo2);
            ndigitos3=redondeaDigitos2(modulo3);
            ndigitos4=redondeaDigitos2(modulo4);
            sumadigitos=ndigitos1+ndigitos2+ndigitos3+ndigitos4;
        }
        if (sumadigitos!=7)
        {
            if (tipo1==0)
             modulo1= pixeles1/Media0;
            else
              modulo1= pixeles1/Media1;

            if (tipo2==0)
                modulo2= pixeles2/Media0;
            else
                modulo2= pixeles2/Media1;

            if (tipo3==0)
                modulo3= pixeles3/Media0;
            else
                modulo3= pixeles3/Media1;

            if (tipo4==0)
                modulo4= pixeles4/Media0;
            else
                modulo4= pixeles4/Media1;

            //Redondeamos los digitos
            ndigitos1=redondeaDigitos(modulo1);
            ndigitos2=redondeaDigitos(modulo2);
            ndigitos3=redondeaDigitos(modulo3);
            ndigitos4=redondeaDigitos(modulo4);
            sumadigitos=ndigitos1+ndigitos2+ndigitos3+ndigitos4;
        }
        if (sumadigitos==7)
        {

            String binario1=ObtieneBinario(tipo1,ndigitos1);
            String binario2=ObtieneBinario(tipo2,ndigitos2);
            String binario3=ObtieneBinario(tipo3,ndigitos3);
            String binario4=ObtieneBinario(tipo4,ndigitos4);



            //Lo dejamos marcado en el array
            //marcamos el array por si tenmos que revisar calculos
            elementos.elementAt(i).setPosicion("DIGITO "+String.valueOf(posicion));
            elementos.elementAt(i).setBinario(binario1);
            elementos.elementAt(i+1).setPosicion("DIGITO "+String.valueOf(posicion));
            elementos.elementAt(i+1).setBinario(binario2);
            elementos.elementAt(i+2).setPosicion("DIGITO "+String.valueOf(posicion));
            elementos.elementAt(i+2).setBinario(binario3);
            elementos.elementAt(i+3).setPosicion("DIGITO "+String.valueOf(posicion));
            elementos.elementAt(i+3).setBinario(binario4);
            //calculamos el ean


            String binario=binario1+binario2+binario3+binario4;
            switch (posicion) {
                case 2:
                    ok=ean13.setDigito2(binario);

                    break;
                case 3:
                    ok=ean13.setDigito3(binario);
                    break;
                case 4:
                    ok=ean13.setDigito4(binario);
                    break;
                case 5:
                    ok=ean13.setDigito5(binario);
                    break;
                case 6:
                    ok=ean13.setDigito6(binario);
                    break;
                case 7:
                    ok=ean13.setDigito7(binario);
                    break;
                case 8:
                    ok=ean13.setDigito8(binario);
                    break;
                case 9:
                    ok=ean13.setDigito9(binario);
                    break;
                case 10:
                    ok=ean13.setDigito10(binario);
                    break;
                case 11:
                    ok=ean13.setDigito11(binario);
                    break;
                case 12:
                    ok=ean13.setDigito12(binario);
                    break;
                case 13:
                    ok=ean13.setDigito13(binario);
                    break;


            }
        }

     return ok;
    }
    //**********************************************************************************************
    //**********************************OPERACIONES*************************************************
   //Obtiene los pixeles de las guradas para recalcular el pixel unitario
    private void calcularPixelUnitario()
    {
        //calculamos los negros
        int x= elementos.elementAt(inicio).getNpixels();
        int x1=elementos.elementAt(inicio+2).getNpixels();
        int x2=elementos.elementAt(fin).getNpixels();
        int x3=elementos.elementAt(fin-2).getNpixels();
        int x4=elementos.elementAt(medio+1).getNpixels();
        int x5=elementos.elementAt(medio+3).getNpixels();
        double xtotal=x+x1+x2+x3+x4+x5;
        this.Media1=xtotal/6;


        int y= elementos.elementAt(inicio+1).getNpixels();
        int y1=elementos.elementAt(medio).getNpixels();
        int y2=elementos.elementAt(medio+2).getNpixels();
        int y3=elementos.elementAt(medio+4).getNpixels();
        int y4=elementos.elementAt(fin-1).getNpixels();
        double ytotal=y+y1+y2+y3+y4;
        this.Media0=ytotal/5;

    }



    //Obtiene el numero binario segun el tipo y la longitud
    private String ObtieneBinario(int tipo,int leng) {
        String str=String.valueOf(tipo);;
        String valor=String.valueOf(tipo);
        for (int i = str.length(); i < leng; i++)
            str += valor;
        return str;
    }
    //redondeo de los digitos hasta 1.6
    private int redondeaDigitos(double ndigitos)
    {
        int numero=0;
        if ((ndigitos>0.1)&&(ndigitos<=1.60))
        {
            numero=1;
        }
        if ((ndigitos>1.60)&&(ndigitos<=2.60)) {
            numero=2;
        }
        if ((ndigitos>2.60)&&(ndigitos<=3.60)) {
            numero=3;
        }
        if ((ndigitos>3.60)&&(ndigitos<=4.60))
        {
            numero=4;
        }
        if ((ndigitos>4.60)&&(ndigitos<=5.60)) {
            numero=5;
        }
        return  numero;

    }
    //redondeo de los digitos hasta 1.5
    private int redondeaDigitos2(double ndigitos)
    {
        int numero=0;
        if ((ndigitos>0.1)&&(ndigitos<=1.50))
        {
            numero=1;
        }
        if ((ndigitos>1.50)&&(ndigitos<=2.50)) {
            numero=2;
        }
        if ((ndigitos>2.50)&&(ndigitos<=3.50)) {
            numero=3;
        }
        if ((ndigitos>3.50)&&(ndigitos<=4.50))
        {
            numero=4;
        }
        if ((ndigitos>4.50)&&(ndigitos<=5.50)) {
            numero=5;
        }
        return  numero;

    }
    //calcula el numero de barras asi sabemos el tipo de EAN EAN13=30 EAN8=22
    private int EAN_numerodeBarras()
    {
        int barras=0;
        for (int i=inicio;i<=fin;i++)
        {
            double tipo = elementos.elementAt(i).getTipo();
            if (tipo==1)
                barras++;

        }//for
        return barras;
    }



    //**********************************************************************************************
    //****************************BUSQUEDA DE GUARDAS EAN*******************************************
    //**********************************************************************************************
    private boolean EAN_BuscarGuardaInicio( )
    {
            boolean ok=false;
            if (elementos.size()-1>=minimoSize) {
                for (int i = 0; i <= elementos.size() - 4; i++) {

                    double tipo0 = elementos.elementAt(i).getTipo();

                    double tipo1 = elementos.elementAt(i + 1).getTipo();

                    double tipo2 = elementos.elementAt(i + 2).getTipo();

                    double tipo3 = elementos.elementAt(i + 3).getTipo();


                    //Buscamos 0 grande 1 0 1

                    if ((tipo0 == 0)&&(tipo1 == 1) && (tipo2 == 0) && (tipo3 == 1)) {
                        //miramos las anchuras
                        double pixeles0 = elementos.elementAt(i).getNpixels();

                        double pixeles1 = elementos.elementAt(i + 1).getNpixels();
                        double pixeles2 = elementos.elementAt(i + 2).getNpixels();
                        double pixeles3 = elementos.elementAt(i + 3).getNpixels();
                        double total = pixeles1 + pixeles2 + pixeles3;
                        if (pixeles0>=(pixeles1+total)) {


                            double modulo1 = (pixeles1 / total) * 3;
                            double modulo2 = (pixeles2 / total) * 3;
                            double modulo3 = (pixeles3 / total) * 3;
                            int ndigitos1 = redondeaDigitos(modulo1);
                            int ndigitos2 = redondeaDigitos(modulo2);
                            int ndigitos3 = redondeaDigitos(modulo3);

                            if ((ndigitos1 == 1) && (ndigitos2 == 1) && (ndigitos3 == 1)) {
                                elementos.elementAt(i+1).setPosicion("GUARDA INICIO");
                                elementos.elementAt(i+1).setBinario("1");
                                elementos.elementAt(i + 2).setPosicion("GUARDA INICIO");
                                elementos.elementAt(i + 2).setBinario("0");
                                elementos.elementAt(i + 3).setPosicion("GUARDA INICIO");
                                elementos.elementAt(i + 3).setBinario("1");
                                //guardamos los indices
                                this.inicio = i+1;//indice inicio array

                                ok = true;
                                break;
                            }
                        }
                    }


                }//for
            }



        return ok;
    }

    private boolean EAN_BuscarGuardaFin( )
    {
        boolean ok=false;

        if (elementos.size()-1>=fin) {
            double tipo1 = elementos.elementAt(fin).getTipo();

            double tipo2 = elementos.elementAt(fin - 1).getTipo();
            double tipo3 = elementos.elementAt(fin - 2).getTipo();

            //Buscamos la secuencia 1 0 1
            if ((tipo1 == 1) && (tipo2 == 0) && (tipo3 == 1)) {
                //miramos las anchuras
                double pixeles1 = elementos.elementAt(fin).getNpixels();
                double pixeles2 = elementos.elementAt(fin-1).getNpixels();
                double pixeles3 = elementos.elementAt(fin-2).getNpixels();
                double pixeles4 = elementos.elementAt(inicio).getNpixels();
                double total = pixeles1 + pixeles2 + pixeles3;
                double modulo1 = (pixeles1 / total) * 3;
                double modulo2 = (pixeles2 / total) * 3;
                double modulo3 = (pixeles3 / total) * 3;
                double modulo4 =pixeles1/pixeles4;
                int ndigitos1 = redondeaDigitos(modulo1);
                int ndigitos2 = redondeaDigitos(modulo2);
                int ndigitos3 = redondeaDigitos(modulo3);
                int ndigitos4 = redondeaDigitos(modulo4);
                //comprobamos que el modulo es 1
            if ((ndigitos1 == 1) && (ndigitos2 == 1) && (ndigitos3 == 1)&& (ndigitos4 == 1)) {
                elementos.elementAt(fin).setPosicion("GUARDA FIN");
                elementos.elementAt(fin).setBinario("1");
                elementos.elementAt(fin - 1).setPosicion("GUARDA FIN");
                elementos.elementAt(fin - 1).setBinario("0");
                elementos.elementAt(fin - 2).setPosicion("GUARDA FIN");
                elementos.elementAt(fin - 2).setBinario("1");

                ok = true;
            }


            }
        }




        return ok;
    }
    private boolean EAN_BuscarGuardaCentral()
    {
        boolean ok=false;

            double tipo1 = elementos.elementAt(this.medio).getTipo();
            double tipo2 = elementos.elementAt(this.medio+1).getTipo();
            double tipo3 = elementos.elementAt(this.medio+2).getTipo();
            double tipo4 = elementos.elementAt(this.medio+3).getTipo();
            double tipo5 = elementos.elementAt(this.medio+4).getTipo();

            //Buscamos 0 1 0 1 0
            if ((tipo1==0)&&(tipo2==1)&&(tipo3==0)&&(tipo4==1)&&(tipo5==0))
            {
                //miramos las anchuras


                double pixeles1 = elementos.elementAt(medio).getNpixels();
                double pixeles2 = elementos.elementAt(medio+1).getNpixels();
                double pixeles3 = elementos.elementAt(medio+2).getNpixels();
                double pixeles4 = elementos.elementAt(medio+3).getNpixels();
                double pixeles5 = elementos.elementAt(medio+4).getNpixels();
                double total = pixeles1 + pixeles2 + pixeles3+pixeles4+pixeles5;
                double modulo1 = (pixeles1 / total) * 5;
                double modulo2 = (pixeles2 / total) * 5;
                double modulo3 = (pixeles3 / total) * 5;
                double modulo4 = (pixeles4 / total) * 5;
                double modulo5 = (pixeles5 / total) * 5;
                int ndigitos1 = redondeaDigitos(modulo1);
                int ndigitos2 = redondeaDigitos(modulo2);
                int ndigitos3 = redondeaDigitos(modulo3);
                int ndigitos4 = redondeaDigitos(modulo4);
                int ndigitos5 = redondeaDigitos(modulo5);
                if ((ndigitos1 == 1) && (ndigitos2 == 1) && (ndigitos3 == 1)&& (ndigitos4 == 1)&&(ndigitos5 == 1))
                {
                    elementos.elementAt(this.medio).setPosicion("GUARDA CENTRAL");
                    elementos.elementAt(this.medio).setBinario("0");
                    elementos.elementAt(this.medio + 1).setPosicion("GUARDA CENTRAL");
                    elementos.elementAt(this.medio + 1).setBinario("1");
                    elementos.elementAt(this.medio + 2).setPosicion("GUARDA CENTRAL");
                    elementos.elementAt(this.medio + 2).setBinario("0");
                    elementos.elementAt(this.medio + 3).setPosicion("GUARDA CENTRAL");
                    elementos.elementAt(this.medio + 3).setBinario("1");
                    elementos.elementAt(this.medio + 4).setPosicion("GUARDA CENTRAL");
                    elementos.elementAt(this.medio + 4).setBinario("0");


                    ok = true;
                }


            }




        return ok;
    }

    //**********************************************************************************************
    //********************************EAN 8*********************************************************
    //**********************************************************************************************

    private void AsignarEan8() {

        Log.e("Barras", "Asignar EAN 13 ");
        ean8 = new EAN8();
        ean8.setGuardaInicio("101");
        ean8.setGuardaFin("101");
        ean8.setGuardaCentro("01010");
        encontrado=false;
        int x=inicio+3;
        boolean continuar=true;
        for (int i=2;i<=5;i++) {

            if(leerDigito2(x,i))
                x+=4;
            else
            {
                continuar=false;
                break;
            }

        }
        if (continuar)
        {
            x=medio+5;
            for (int i=6;i<=9;i++) {

                if(leerDigito2(x,i))
                    x+=4;
                else
                {
                    continuar=false;
                    break;
                }

            }
        }
        if (continuar)
        {
            if (ean8.getCorrecto()) {
                encontrado = true;
            }
        }


    }
    private boolean leerDigito2(int i,int posicion)
    {
        boolean ok=false;
        int tipo1 = elementos.elementAt(i).getTipo();
        double pixeles1 = elementos.elementAt(i).getNpixels();
        int tipo2 = elementos.elementAt(i+1).getTipo();
        double pixeles2 = elementos.elementAt(i+1).getNpixels();
        int tipo3 = elementos.elementAt(i+2).getTipo();
        double pixeles3 = elementos.elementAt(i+2).getNpixels();
        int tipo4 = elementos.elementAt(i+3).getTipo();
        double pixeles4 = elementos.elementAt(i+3).getNpixels();
        //calculamos el modulo
        double total=pixeles1+pixeles2+pixeles3+pixeles4;
        double modulo1= (pixeles1/total)*7;
        double modulo2= (pixeles2/total)*7;
        double modulo3= (pixeles3/total)*7;
        double modulo4= (pixeles4/total)*7;
        //Redondeamos los digitos
        int ndigitos1=redondeaDigitos(modulo1);
        int ndigitos2=redondeaDigitos(modulo2);
        int ndigitos3=redondeaDigitos(modulo3);
        int ndigitos4=redondeaDigitos(modulo4);

        int sumadigitos=ndigitos1+ndigitos2+ndigitos3+ndigitos4;
        if (sumadigitos!=7)
        {
            //cambiamos el redondeo
            ndigitos1=redondeaDigitos2(modulo1);
            ndigitos2=redondeaDigitos2(modulo2);
            ndigitos3=redondeaDigitos2(modulo3);
            ndigitos4=redondeaDigitos2(modulo4);
            sumadigitos=ndigitos1+ndigitos2+ndigitos3+ndigitos4;
        }
        if (sumadigitos!=7)
        {
            if (tipo1==0)
                modulo1= pixeles1/Media0;
            else
                modulo1= pixeles1/Media1;

            if (tipo2==0)
                modulo2= pixeles2/Media0;
            else
                modulo2= pixeles2/Media1;

            if (tipo3==0)
                modulo3= pixeles3/Media0;
            else
                modulo3= pixeles3/Media1;

            if (tipo4==0)
                modulo4= pixeles4/Media0;
            else
                modulo4= pixeles4/Media1;

            //Redondeamos los digitos
            ndigitos1=redondeaDigitos(modulo1);
            ndigitos2=redondeaDigitos(modulo2);
            ndigitos3=redondeaDigitos(modulo3);
            ndigitos4=redondeaDigitos(modulo4);
            sumadigitos=ndigitos1+ndigitos2+ndigitos3+ndigitos4;
        }
        if (sumadigitos==7)
        {

            String binario1=ObtieneBinario(tipo1,ndigitos1);
            String binario2=ObtieneBinario(tipo2,ndigitos2);
            String binario3=ObtieneBinario(tipo3,ndigitos3);
            String binario4=ObtieneBinario(tipo4,ndigitos4);



            //Lo dejamos marcado en el array
            //marcamos el array por si tenmos que revisar calculos
            elementos.elementAt(i).setPosicion("DIGITO "+String.valueOf(posicion));
            elementos.elementAt(i).setBinario(binario1);
            elementos.elementAt(i+1).setPosicion("DIGITO "+String.valueOf(posicion));
            elementos.elementAt(i+1).setBinario(binario2);
            elementos.elementAt(i+2).setPosicion("DIGITO "+String.valueOf(posicion));
            elementos.elementAt(i+2).setBinario(binario3);
            elementos.elementAt(i+3).setPosicion("DIGITO "+String.valueOf(posicion));
            elementos.elementAt(i+3).setBinario(binario4);
            //calculamos el ean


            String binario=binario1+binario2+binario3+binario4;
            switch (posicion) {
                case 2:
                    ok=ean8.setDigito2(binario);

                    break;
                case 3:
                    ok=ean8.setDigito3(binario);
                    break;
                case 4:
                    ok=ean8.setDigito4(binario);
                    break;
                case 5:
                    ok=ean8.setDigito5(binario);
                    break;
                case 6:
                    ok=ean8.setDigito6(binario);
                    break;
                case 7:
                    ok=ean8.setDigito7(binario);
                    break;
                case 8:
                    ok=ean8.setDigito8(binario);
                    break;
                case 9:
                    ok=ean8.setDigito9(binario);
                    break;



            }
        }

        return ok;
    }


    public EAN13 getEan13() {
        return ean13;
    }
    public boolean isEncontrado() {
        return encontrado;
    }
    public String getTipo() {
        return tipo;
    }
    public EAN8 getEan8() {
        return ean8;
    }


}
