package es.rotxo.escaner;

import android.app.Activity;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.AudioManager;
import android.media.ToneGenerator;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.PowerManager;
import android.preference.PreferenceManager;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;


import org.opencv.android.JavaCameraView; //presenta un flujo de vídeo de una cámara
import org.opencv.android.InstallCallbackInterface;
import org.opencv.android.LoaderCallbackInterface;
import org.opencv.android.OpenCVLoader;
import org.opencv.android.Utils;
import org.opencv.core.Mat;

import org.opencv.core.Size;
import org.opencv.imgcodecs.Imgcodecs;
import org.opencv.imgproc.Imgproc;
import com.github.fafaldo.fabtoolbar.widget.FABToolbarLayout;

import java.io.File;

public class MainActivity extends Activity implements MiCamaraView.CvCameraViewListener2, LoaderCallbackInterface //manejan el arranque y la parada de un flujo de vídeo
{

    public TextView codBarras;
    public SeekBar miZoom;
    private static final String TAG = "Escaner MainActivity";
    private MiCamaraView cameraView;

    //Seleccion camara y tamño
    private int indiceCamara; // 0-> camara trasera; 1-> camara frontal
    private int cam_anchura =1920;// resolucion deseada de la imagen
    private int cam_altura=1080;
    private final String STATE_CAMERA_INDEX = "cameraIndex";




    Procesador procesador;

    ToneGenerator toneGen1;
    protected PowerManager.WakeLock wakelock;
    private  miToast mostraBarras;
    private FABToolbarLayout morph;
    public boolean mimenu=false;
    public Activity THIS;
    public Handler mostrarCodBarras = new Handler() {
        @Override
        public void handleMessage(Message msg) {

            try {
                 String codigoBarras=((Aplicacion) getApplication()).getCodigoBarras();
                 String codigoBarrasAnterior=((Aplicacion) getApplication()).getCodigoBarrasAnterior();

                //  codBarras.setText(msg.obj.toString());

                if (!codigoBarras.equals(codigoBarrasAnterior)) {

                    toneGen1 = new ToneGenerator(AudioManager.STREAM_MUSIC, 100);
                    toneGen1.startTone(ToneGenerator.TONE_CDMA_PIP, 150);
                    mostraBarras.show(msg.obj.toString());
                    codBarras.setText(msg.obj.toString());
                }



                ((Aplicacion) getApplication()).setCodigoBarrasAnterior(msg.obj.toString());
                ((Aplicacion) getApplication()).setCodigoBarras("");

            }catch(Exception m)
            {

            }

        }
    };



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        overridePendingTransition(R.anim.entrada_alfa, R.anim.salida_alfa);
        THIS=this;

        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        morph = (FABToolbarLayout) findViewById(R.id.fabtoolbar);
        View  uno = findViewById(R.id.uno);
        View  tres = findViewById(R.id.tres);
        View  cuatro = findViewById(R.id.cuatro);

        fab.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if(!mimenu)
                {
                    morph.show();
                    mimenu=true;
                }
                else
                {
                    morph.hide();
                    mimenu=false;
                }

            }
        });
        uno.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {

                //cerramos la barra
                morph.hide();
                mimenu=false;
            }
        });

        tres.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {

              if (((Aplicacion) getApplication()).hayDatosLista()) {
                  Intent h = new Intent(THIS, ListadoBarras.class);
                  startActivity(h);
                  overridePendingTransition(R.anim.entrada_derecha, R.anim.salida_izquierda);
              }else
              {
                  Toast.makeText(MainActivity.this,"El Historial está vacío." , Toast.LENGTH_LONG).show();
              }
                morph.hide();
                mimenu=false;
            }
        });
        cuatro.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {

                Intent i = new Intent(THIS, PreferenciasActivity.class);
                startActivity(i);
                morph.hide();
                mimenu=false;
            }
        });



        //obtenemos la maxima resolucion de la camara

        cameraView = (MiCamaraView) findViewById(R.id.vista_camara);
        cameraView.setCvCameraViewListener(this);
        cameraView.setZoomControl((SeekBar) findViewById(R.id.CameraZoomControls));
        codBarras=(TextView) findViewById(R.id.CodBarras);
        miZoom=(SeekBar) findViewById(R.id.CameraZoomControls);
        indiceCamara = MiCamaraView.CAMERA_ID_BACK;

        //evitar que la pantalla se apague
        final PowerManager pm=(PowerManager)getSystemService(Context.POWER_SERVICE);
        this.wakelock=pm.newWakeLock(PowerManager.SCREEN_DIM_WAKE_LOCK, "etiqueta");
        wakelock.acquire();


        mostraBarras= new miToast(this.getApplicationContext(), Toast.LENGTH_LONG);
        mostraBarras.setGravity(Gravity.CENTER, 0, 0);

        SharedPreferences preferencias = PreferenceManager .getDefaultSharedPreferences(this);
        boolean visiblezoom = (preferencias.getBoolean("zoom", false));
        if (!visiblezoom)
            miZoom.setVisibility(View.GONE);
        else
            miZoom.setVisibility(View.VISIBLE);


    }



    @Override
    public void onPause() {
        super.onPause();
        if (cameraView != null)
            cameraView.disableView();
    }
    @Override
    public void onResume()
    {
        super.onResume();
        cargarPreferencias();
        OpenCVLoader.initAsync(OpenCVLoader.OPENCV_VERSION_3_1_0, this, this);
        wakelock.acquire();

    }
    @Override
    public void onDestroy() {
        super.onDestroy();
        if (cameraView != null)
            cameraView.disableView();

        this.wakelock.release();
    }

    private void cargarPreferencias()
    {
        //OBTENEMOS LOS VALORES DE LAS PREFERENCIAS
        SharedPreferences preferencias = PreferenceManager .getDefaultSharedPreferences(this);
        boolean visiblezoom = (preferencias.getBoolean("zoom", false));
        if (!visiblezoom)
            miZoom.setVisibility(View.GONE);
        else
            miZoom.setVisibility(View.VISIBLE);
        // Actualizamos los valores de aplicacion
        ((Aplicacion) getApplication()).setTorch((preferencias.getBoolean("torch", false)));
        ((Aplicacion) getApplication()).zoomValorDePreferencias((preferencias.getString("zoomValor", "0")));
        ((Aplicacion) getApplication()).setGuardarHistorial((preferencias.getBoolean("Historial", true)));
        ((Aplicacion) getApplication()).setMultipleLectura((preferencias.getBoolean("MultipleLectura", false)));
    }

    //******************Interface CvCameraViewListener2**************************************************************************************************
    //proporcionan un mecanismo de callback para manejar el arranque y la parada de un flujo de vídeo así como manejar la captura de cada fotograma.
    @Override
    public void onCameraViewStarted(int width, int height) {

        cam_altura = height; //Estas son las que se usan de verdad
        cam_anchura = width;
        procesador = new Procesador(this);


    }

    @Override
    public void onCameraViewStopped() {

    }

    //Cada vez que hay un nuevo fotograma se ejecuta
    @Override
    public Mat onCameraFrame(MiCamaraView.CvCameraViewFrame inputFrame) {
        Mat entrada;



        entrada = inputFrame.gray();

        Mat salida = procesador.procesa(entrada);
        String codigoBarras=((Aplicacion) getApplication()).getCodigoBarras();
        if (!codigoBarras.equals("")) {
            Message msg = new Message();
            msg.obj = codigoBarras;

            mostrarCodBarras.sendMessage(msg);
        }




        return salida;
    }
    //***************FIN Interface CvCameraViewListener2**************************************************************************************************

    // ***************Interface LoaderCallbackInterface*************************************************************************************************
    @Override
    public void onManagerConnected(int status)
    {
        switch (status)
        {
            case LoaderCallbackInterface.SUCCESS:
                Log.i(TAG, "OpenCV se cargo correctamente");
                cameraView.setMaxFrameSize(cam_anchura, cam_altura);
                cameraView.enableView();
                break;
            default:
                Log.e(TAG, "OpenCV no se cargo");
                Toast.makeText(MainActivity.this, "OpenCV no se cargo", Toast.LENGTH_LONG).show();
                finish();
                break;
        }
    }

    @Override
    public void onPackageInstall(int operation, InstallCallbackInterface callback) {
        Toast.makeText(MainActivity.this, "Necesitas Instalar Opencv Manager 3.1.0", Toast.LENGTH_LONG).show();

    }
    // ***************fin Interface LoaderCallbackInterface*************************************************************************************************

    public boolean onTouchEvent(MotionEvent event) {
        //openOptionsMenu();
        return true;
    }

    public void onSaveInstanceState(Bundle savedInstanceState)
    {
// Save the current camera index.
        savedInstanceState.putInt(STATE_CAMERA_INDEX, indiceCamara);
        this.wakelock.release();
        super.onSaveInstanceState(savedInstanceState);
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
        super.onCreateOptionsMenu(menu);
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu, menu);

        return true;
    }





}
